/* LSAGPI                                       */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/



package lsagpi;

import java.util.StringTokenizer;
import java.util.Vector;

/**
 * Clase para definir acciones.
 * @author Miguel Angel Pescador Santirso
 */
public class Accion {
final int DI=0;
final int MOVER=1;
final int GIRAR=2;
final int ESPERAR=3;
final int SALIR=4;
final int SELECCIONARPOSICION=5;
final int SELECCIONARTINTA=6;
final int SELECCIONARETIQUETA=7;
final int SELECCIONARJUGADOR=8;
final int DORMIR=9;
final int CAMINAR=10;
final int SALTAR=11;
final int SI=12;
final int ENTONCES=13;
final int OTRO=14;
final int MIENTRAS=15;
final int PARA=16;
final int COLOCAR=17;
final int LOCALIZAR=18;
final int DAR=19;
final int ACTIVARPANEL=20;
final int LIMPIARPANEL=21;
final int ADDPREGUNTA=22;
final int ESPERARESPUESTA=23;
final int SELECCIONARACTITUD=24;
final int SELECCIONARANIMACION=25;
final int LLAMAPROCEDIMIENTO=26;
final int TRANSICION=27;
final int COGER=28;
//Operaciones sobre variables
final int ADD=301;
final int ADDV=302;
final int LET=303;
final int MULT=304;
final int RAND=305;
// Operadores de comparación para SI-ENTONCES-OTRO MIENTRAS-ENTONCES PARA-ENTONCES
    final int COLISION=0;
    final int EQ=1;
    final int EQI=2;
    final int EQR=3;
    final int EQS=4;
    final int EQSV=5;
    final int EQV=6;
    final int GE=7;
    final int GEV=8;
    final int GT=9;
    final int GTV=10;
    final int DENTRO=11;
    final int ESJUGADOR=12;
    final int LE=13;
    final int LEV=14;
    final int LT=15;
    final int LTV=16;
    final int NE=17;
    final int NEV=18;
    final int PRESENTE=19;
    final int COGIDO=20;
    final int AND=100;
    final int OR=101;
    final int NOT=102;

Vector instruccion=new Vector();
Vector<Vector> acciones=new Vector<Vector>();
boolean nopasar=false;
/**
 * Constructor de Accion
 * @param definicion Definicion de la Accion.
 */
    public Accion(String definicion){
        StringTokenizer st = new StringTokenizer(definicion,"\n",true);
        //nombre=st.nextToken();
        System.out.println(definicion);
        while (st.hasMoreTokens())
		{
            String cadena=new String("");
            if(nopasar==false){
                cadena=st.nextToken();
            }else{
                nopasar=false;
            }
            if(cadena.indexOf("INSTRUCCION")!=-1){
                StringTokenizer ins_tok=new StringTokenizer(cadena," ");
                System.out.println(cadena);
                String condicion=new String("");
                condicion = ins_tok.nextToken().trim();
                while(!condicion.equals("INSTRUCCION")&& ins_tok.hasMoreTokens()){
                    condicion = ins_tok.nextToken().trim();
                    System.out.println(condicion);
                }
                
                System.out.println(condicion);
                if(condicion.equals("INSTRUCCION")){
                    while(ins_tok.hasMoreTokens()){
                        String ins=ins_tok.nextToken();
                        if(ins.indexOf("{")==-1)
                            System.out.println(ins.trim());
                            instruccion.add(ins.trim());
                    }
                }
            }
            if(cadena.indexOf("{")!=-1)
                st.nextToken();
            if(cadena.indexOf("DI")!=-1){
                Vector accion=new Vector();
                System.out.println("Un DI");
                StringTokenizer ins_tok=new StringTokenizer(cadena," ");
                if(ins_tok.nextToken().trim().equals("DI")){
                    accion.add(DI);
                    accion.add(ins_tok.nextToken().trim());
                    String texto=new String("");
                    while(ins_tok.hasMoreTokens()){
                          texto+=ins_tok.nextToken()+" ";
                        }
                    System.out.println(texto.substring(1,texto.length()-3));
                    accion.add(texto.substring(1,texto.length()-3));
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("MOVER")!=-1){
                Vector accion=new Vector();
                System.out.println("Un MOVER");
                accion.add(MOVER);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("MOVER")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                    
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("SELECCIONARTINTA")!=-1){
                Vector accion=new Vector();
                System.out.println("Un SELECCIONARTINTA");
                accion.add(SELECCIONARTINTA);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("SELECCIONARTINTA")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("SELECCIONARPOSICION")!=-1){
                Vector accion=new Vector();
                System.out.println("Un SELECCIONARPOSICION");
                accion.add(SELECCIONARPOSICION);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("SELECCIONARPOSICION")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());

                }
                acciones.add(accion);
            }
            if(cadena.indexOf("SELECCIONARETIQUETA")!=-1){
                Vector accion=new Vector();
                System.out.println("Un SELECCIONARETIQUETA");
                accion.add(SELECCIONARETIQUETA);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("SELECCIONARETIQUETA")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("SELECCIONARJUGADOR")!=-1){
                Vector accion=new Vector();
                System.out.println("Un SELECCIONARJUGADOR");
                accion.add(SELECCIONARJUGADOR);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("SELECCIONARJUGADOR")){
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("ESPERAR ")!=-1){
                Vector accion=new Vector();
                 System.out.println("Un ESPERAR");
                accion.add(ESPERAR);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("ESPERAR")){
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("DORMIR")!=-1){
                Vector accion=new Vector();
                 System.out.println("Un DORMIR");
                accion.add(DORMIR);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("DORMIR")){
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("GIRAR")!=-1){
                Vector accion=new Vector();
                System.out.println("Un GIRAR");
                accion.add(GIRAR);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("GIRAR")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("SALTAR")!=-1){
                Vector accion=new Vector();
                System.out.println("Un SALTAR");
                accion.add(SALTAR);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("SALTAR")){
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("ADD ")!=-1){
                Vector accion=new Vector();
                System.out.println("Un ADD");
                accion.add(ADD);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("ADD")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("ADDV")!=-1){
                Vector accion=new Vector();
                System.out.println("Un ADDV");
                accion.add(ADDV);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("ADDV")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("LET")!=-1){
                Vector accion=new Vector();
                System.out.println("Un LET");
                accion.add(LET);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("LET")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("RAND")!=-1){
                Vector accion=new Vector();
                System.out.println("Un RAND");
                accion.add(LET);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("RAND")){
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("DAR")!=-1){
                Vector accion=new Vector();
                System.out.println("Un DAR");
                accion.add(DAR);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("DAR")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("COGER")!=-1){
                Vector accion=new Vector();
                System.out.println("Un COGER");
                accion.add(COGER);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("COGER")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("COLOCAR")!=-1){
                Vector accion=new Vector();
                System.out.println("Un COLOCAR");
                accion.add(COLOCAR);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("COLOCAR")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("LOCALIZAR")!=-1){
                Vector accion=new Vector();
                System.out.println("Un LOCALIZAR");
                accion.add(LOCALIZAR);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("LOCALIZAR")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("CAMINAR")!=-1){
                Vector accion=new Vector();
                System.out.println("Un CAMINAR");
                accion.add(CAMINAR);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("CAMINAR")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("SALIR")!=-1){
                Vector accion=new Vector();
                accion.add(SALIR);
                acciones.add(accion);
            }
            if(cadena.indexOf("ADDPREGUNTA")!=-1){
                Vector accion=new Vector();
                System.out.println("Un ADDPREGUNTA");
                accion.add(ADDPREGUNTA);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("ADDPREGUNTA")){
                    String texto=new String("");
                    while(ins_tok.hasMoreTokens()){
                        texto+=ins_tok.nextToken()+" ";
                    }
                    accion.add(texto.substring(1,texto.length()-4));
                    accion.add((texto.substring(texto.length()-2,texto.length()-1)).trim());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("ACTIVARPANEL")!=-1){
                Vector accion=new Vector();
                System.out.println("Un ACTIVARPANEL");
                accion.add(ACTIVARPANEL);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("ACTIVARPANEL")){
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("LIMPIARPANEL")!=-1){
                Vector accion=new Vector();
                System.out.println("Un LIMPIARPANEL");
                accion.add(LIMPIARPANEL);
                acciones.add(accion);
            }
            if(cadena.indexOf("ESPERARESPUESTA")!=-1){
                Vector accion=new Vector();
                System.out.println("Un ESPERARESPUESTA");
                accion.add(ESPERARESPUESTA);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("ESPERARESPUESTA")){
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("SELECCIONARANIMACION")!=-1){
                Vector accion=new Vector();
                System.out.println("Un SELECCIONARANIMACION");
                accion.add(SELECCIONARANIMACION);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("SELECCIONARANIMACION")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("SELECCIONARACTITUD")!=-1){
                Vector accion=new Vector();
                System.out.println("Un SELECCIONARACTITUD");
                accion.add(SELECCIONARACTITUD);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("SELECCIONARACTITUD")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            //Inicio de bloques lógicos
            if(cadena.indexOf("SI")!=-1){
                System.out.println("Bloque SI");
                String num=new String("");
                Vector expresion=new Vector();
                if(cadena.indexOf("SI")!=-1 || cadena.indexOf("{")!=-1){
                cadena=st.nextToken();}
                StringTokenizer num_tok=new StringTokenizer(cadena," ");
                while(num_tok.hasMoreTokens()){
                    num=num_tok.nextToken().trim();
                    if(num.equals("{") && num_tok.hasMoreTokens()){
                        System.out.println("entra");
                        expresion.add(SI);
                        System.out.println("Añadido SI");
                        Vector comparacion=new Vector();
                        String num2=num_tok.nextToken().trim();
                        comparacion.add(dameTipo(num2));
                        while(num_tok.hasMoreTokens()){
                            num2=num_tok.nextToken().trim();
                            System.out.println(num2);
                            comparacion.add(num2);
                        }
                        if(!comparacion.get(1).toString().equals("}")){
                            expresion.add(comparacion);
                            System.out.println("Añadido COMPARACION");
                        }

                    }else{
                        cadena=st.nextToken();
                        while(cadena.indexOf("{")!=-1 || cadena.trim().isEmpty())
                            cadena=st.nextToken();
                        System.out.println("entra2");
                        //cadena=st.nextToken();
                        System.out.println("Debería ser la comparacion: "+cadena);
                        StringTokenizer num2_tok=new StringTokenizer(cadena);
                        expresion.add(SI);
                        System.out.println("Añadido SI");
                        Vector comparacion=new Vector();
                        String num2=num2_tok.nextToken().trim();
                        comparacion.add(dameTipo(num2));
                        while(num2_tok.hasMoreTokens()){
                            num2=num2_tok.nextToken().trim();
                            System.out.println(num2);
                            comparacion.add(num2);
                        }
                        System.out.println("Comparacion: "+comparacion.toString());
                        if(!comparacion.get(1).toString().equals("}")){
                            expresion.add(comparacion);
                            System.out.println("Añadido comparacion");
                        }
                    }

                }
                System.out.println(cadena);
                cadena=st.nextToken();
                System.out.println(cadena);
                while(cadena.indexOf("}")!=-1 || cadena.trim().isEmpty())
                    cadena=st.nextToken();
                if (cadena.indexOf("ENTONCES")!=-1){
                    System.out.println("Bloque ENTONCES");
                    cadena=st.nextToken();
                    String cadenaEntonces=new String("");
                    while(cadena.indexOf("{")==-1)
                        cadena=st.nextToken();
                    int contador=0;
                    while(contador!=-1){
                        cadena=st.nextToken();
                        if(cadena.indexOf("{")!=-1){
                            contador++;
                            cadenaEntonces+=cadena;
                        }else if(cadena.indexOf("{")!=-1 && cadena.indexOf("}")!=-1){
                            cadenaEntonces+=cadena;
                        }else if(cadena.indexOf("}")!=-1){
                            contador--;
                            cadenaEntonces+=cadena;
                        }else{
                            cadenaEntonces+=cadena;
                        }
                    }
                    System.out.println(cadenaEntonces);
                    Accion a=new Accion(cadenaEntonces);
                    expresion.add(a.acciones);
                    System.out.println("Añadido Acciones");
                    System.out.println("Numero de indice: "+expresion.indexOf(a.acciones)+"\nContenido: "+a.acciones);

                }
                /*cadena=st.nextToken();
                while(cadena.indexOf("}")!=-1 || cadena.trim().isEmpty())
                    cadena=st.nextToken();
                if (cadena.indexOf("OTRO")!=-1){
                     System.out.println("Bloque OTRO");
                    cadena=st.nextToken();
                    String cadenaEntonces=new String("");
                    if(cadena.indexOf("{")!=-1)
                        cadena=st.nextToken();
                    int contador=0;
                    while(contador!=-1){
                        cadena=st.nextToken();
                        if(cadena.indexOf("{")!=-1){
                            contador++;
                            cadenaEntonces+=cadena;
                        }else if(cadena.indexOf("{")!=-1 && cadena.indexOf("}")!=-1){
                            cadenaEntonces+=cadena;
                        }else if(cadena.indexOf("}")!=-1){
                            contador--;
                            cadenaEntonces+=cadena;
                        }else{
                            cadenaEntonces+=cadena;
                        }
                    }
                    System.out.println(cadenaEntonces);
                    Accion a=new Accion(cadenaEntonces);
                    expresion.add(a.acciones);

                }else{nopasar=true;}
                acciones.add(expresion);
            }
            Bloque ENTONCES
            if (cadena.indexOf("ENTONCES")!=-1){
                    System.out.println("Bloque ENTONCES");
                    cadena=st.nextToken();
                    String cadenaEntonces=new String("");
                    while(cadena.indexOf("{")==-1)
                        cadena=st.nextToken();
                    int contador=0;
                    while(contador!=-1){
                        cadena=st.nextToken();
                        if(cadena.indexOf("{")!=-1){
                            contador++;
                            cadenaEntonces+=cadena;
                        }else if(cadena.indexOf("{")!=-1 && cadena.indexOf("}")!=-1){
                            cadenaEntonces+=cadena;
                        }else if(cadena.indexOf("}")!=-1){
                            contador--;
                            cadenaEntonces+=cadena;
                        }else{
                            cadenaEntonces+=cadena;
                        }
                    }
                    System.out.println(cadenaEntonces);
                    Accion a=new Accion(cadenaEntonces);
                    for(int i=0;i<a.acciones.size();i++){
                        acciones.add(a.acciones.get(i));
                    }*/

                    acciones.add(expresion);
                }

            if(cadena.indexOf("PARA")!=-1){
                Vector accion=new Vector();
                accion.add(SALIR);
            }
            if(cadena.indexOf("MIENTRAS")!=-1){
                System.out.println("Bloque MIENTRAS");
                String num=new String("");
                Vector expresion=new Vector();
                if(cadena.indexOf("MIENTRAS")!=-1 || cadena.indexOf("{")!=-1){
                    cadena=st.nextToken();
                }
                StringTokenizer num_tok=new StringTokenizer(cadena," ");
                while(num_tok.hasMoreTokens()){
                    num=num_tok.nextToken();
                    if(num.equals("{") && num_tok.hasMoreTokens()){
                        System.out.println("entra");
                        expresion.add(MIENTRAS);
                        System.out.println("Añadido Mientras");
                        Vector comparacion=new Vector();
                        String num2=num_tok.nextToken().trim();
                        comparacion.add(dameTipo(num2));
                        while(num_tok.hasMoreTokens()){
                            num2=num_tok.nextToken().trim();
                            comparacion.add(num2);
                        }
                        if(!comparacion.get(1).toString().equals("}")){
                            expresion.add(comparacion);
                            System.out.println("Añadido COMPARACION");
                        }
                    }else{
                        cadena=st.nextToken();

                        while(cadena.indexOf("{")!=-1 || cadena.trim().isEmpty())
                            cadena=st.nextToken();
                        System.out.println("entra2");
                        //cadena=st.nextToken();
                        System.out.println("Debería ser la comparacion: "+cadena);
                        StringTokenizer num2_tok=new StringTokenizer(cadena);
                        expresion.add(MIENTRAS);
                        System.out.println("Añadido MIENTRAS");
                        Vector comparacion=new Vector();
                        String num2=num2_tok.nextToken().trim();
                        comparacion.add(dameTipo(num2));
                        while(num2_tok.hasMoreTokens()){
                            num2=num2_tok.nextToken().trim();
                            comparacion.add(num2);
                        }
                        if(!comparacion.get(1).toString().equals("}")){
                            expresion.add(comparacion);
                            System.out.println("Añadido COMPARACION");
                    }

                }
                System.out.println(cadena);
                cadena=st.nextToken();
                System.out.println(cadena);
                while(cadena.indexOf("}")!=-1 || cadena.trim().isEmpty())
                    cadena=st.nextToken();
                if (cadena.indexOf("ENTONCES")!=-1){
                    System.out.println("Bloque ENTONCES");
                    cadena=st.nextToken();
                    String cadenaEntonces=new String("");
                    while(cadena.indexOf("{")==-1)
                        cadena=st.nextToken();
                    int contador=0;
                    while(contador!=-1){
                        cadena=st.nextToken();
                        if(cadena.indexOf("{")!=-1){
                            contador++;
                            cadenaEntonces+=cadena;
                        }else if(cadena.indexOf("{")!=-1 && cadena.indexOf("}")!=-1){
                            cadenaEntonces+=cadena;
                        }else if(cadena.indexOf("}")!=-1){
                            contador--;
                            cadenaEntonces+=cadena;
                        }else{
                            cadenaEntonces+=cadena;
                        }
                    }
                    System.out.println(cadenaEntonces);
                    Accion a=new Accion(cadenaEntonces);
                    expresion.add(a.acciones);
                    System.out.println("Añadido aCCIONES");
                    System.out.println(expresion.toString());

                }
                acciones.add(expresion);            
        }
    }
        }
    }
    /**
     * Devuelve el entero que identifica el tipo de accion.
     * @param cadenaTipo String con el nombre de la accion.
     * @return Numero que corresponde a dicha accion.
     */
    public int dameTipo(String cadenaTipo){
        int numeroTipo=0;
        if(cadenaTipo.equals("COLISION")){
           numeroTipo= COLISION;}
        else if(cadenaTipo.equals("EQ")){
           numeroTipo= EQ;}
        else if(cadenaTipo.equals("EQR")){
           numeroTipo= EQR;}
        else if(cadenaTipo.equals("EQS")){
           numeroTipo= EQS;}
        else if(cadenaTipo.equals("EQSV")){
           numeroTipo= EQSV;}
        else if(cadenaTipo.equals("EQV")){
           numeroTipo= EQV;}
        else if(cadenaTipo.equals("GE")){
           numeroTipo= GE;}
        else if(cadenaTipo.equals("GEV")){
           numeroTipo= GEV;}
        else if(cadenaTipo.equals("GT")){
           numeroTipo= GT;}
        else if(cadenaTipo.equals("GTV")){
           numeroTipo= GTV;}
        else if(cadenaTipo.equals("DENTRO")){
           numeroTipo= DENTRO;}
        else if(cadenaTipo.equals("ESJUGADOR")){
           numeroTipo= ESJUGADOR;}
        else if(cadenaTipo.equals("LE")){
           numeroTipo= LE;}
        else if(cadenaTipo.equals("LEV")){
           numeroTipo= LEV;}
        else if(cadenaTipo.equals("LT")){
           numeroTipo= LT;}
        else if(cadenaTipo.equals("LTV")){
           numeroTipo= LTV;}
        else if(cadenaTipo.equals("NE")){
           numeroTipo= NE;}
        else if(cadenaTipo.equals("NEV")){
           numeroTipo= NEV;}
        else if(cadenaTipo.equals("PRESENTE")){
           numeroTipo= PRESENTE;}
        else if(cadenaTipo.equals("COGIDO")){
           numeroTipo= COGIDO;}
        return numeroTipo;
    }
}
