/* LSAGPI                                       */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/

package lsagpi;

import javax.swing.ImageIcon;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JSeparator;

/**
 * Clase que genera la barra de menus.
 * @author Miguel Angel Pescador Santirso
 */
public class BarraDeMenus{

	//Iconos
	ImageIcon im0=new ImageIcon("images/New24.gif");
	ImageIcon im1=new ImageIcon("images/Open24.gif");
	ImageIcon im2=new ImageIcon("images/SaveAs24.gif");
	ImageIcon im3=new ImageIcon("images/Exit24.gif");
	ImageIcon im6=new ImageIcon("images/Help24.gif");
	ImageIcon im7=new ImageIcon("images/Information24.gif");
	ImageIcon im8=new ImageIcon("images/Preferences24.gif");
	//Barra de Menus
	JMenuBar barrademenus=new JMenuBar();
	//Menus
	JMenu archivo=new JMenu("Archivo");
	JMenu opciones=new JMenu("Opciones");
	JMenu ayuda=new JMenu("Ayuda");
	//Menu Archivo
	JMenuItem nuejue=new JMenuItem("Nuevo Juego",im0);
	JMenuItem cargarjue=new JMenuItem("Cargar Juego",im1);
	JMenuItem guardarjue=new JMenuItem("Salvar Juego",im2);
	JSeparator sp0=new JSeparator();
    JMenuItem imporscript=new JMenuItem("Importar Script",im2);
    JSeparator sp1=new JSeparator();
	JMenuItem salir=new JMenuItem("Salir",im3);
	//Menu Opciones
	JMenuItem sonido=new JMenuItem("Sonido");
	JMenu textspeed=new JMenu("Velocidad de Texto");
        JMenuItem lento=new JMenuItem("Lento");
        JMenuItem normal=new JMenuItem("Normal");
        JMenuItem rapido=new JMenuItem("Rapido");
    JSeparator sp2=new JSeparator();
    JMenuItem showbox=new JMenuItem("Mostrar Cajas");
    JMenuItem showconsole=new JMenuItem("Mostrar Consola");
    JMenuItem pantallacompleta=new JMenuItem("Pantalla Completa");

    //Menu Ayuda
	JMenuItem indice=new JMenuItem("Indice",im6);
	JSeparator sp3=new JSeparator();
	JMenuItem acerca=new JMenuItem("Acerca de...",im7);
/**
 * Devuelve la barra de menus generada.
 * @return JMenuBar barra de menus generada.
 */
 public JMenuBar getMenuBar(){

	    archivo.add(nuejue);
		archivo.add(cargarjue);
    	archivo.add(guardarjue);
		archivo.add(sp0);
        archivo.add(imporscript);
        archivo.add(sp1);
    	archivo.add(salir);
		opciones.add(sonido);
            textspeed.add(lento);
            textspeed.add(normal);
            textspeed.add(rapido);
		opciones.add(textspeed);   
		opciones.add(sp2);
		opciones.add(showbox);
		opciones.add(showconsole);
        opciones.add(pantallacompleta);
		ayuda.add(indice);
		ayuda.add(sp3);
		ayuda.add(acerca);
    	 	barrademenus.add(archivo);
 	 	barrademenus.add(opciones);
 	 	barrademenus.add(ayuda);
 	 	return barrademenus;
 	 }

 }

