/* lsagpi                                       */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/

package lsagpi;

import java.awt.Graphics2D;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.util.Vector;
import javax.swing.JPanel;

/**
 * Clase para la gestion de eventos de ratón en la aventura.
 * @author Miguel Angel
 */
public class GestorRaton implements MouseListener, MouseMotionListener{
    Aventura propietario;
    
    public GestorRaton(Aventura a){
        propietario=a;
    }
     /**
     * Gestor del evento click del raton.
     * @param e MouseEvent evento del raron.
     */
    public void mouseClicked(MouseEvent e) {

        //repaint();
       if(propietario.sis.paneldeconversacion==false){
       if(e.getY()<(int)(propietario.sis.PANTALLAVERTICAL*0.66) || (e.getY()>(int)(propietario.sis.PANTALLAVERTICAL*0.66) && e.getX()>(int)(propietario.sis.PANTALLAHORIZONTAL*0.45))){
            if(propietario.fijarverbo==true){
            parsearVerbo(propietario.verboActual,e.getX(),e.getY());
            }else if(propietario.fijarverbo==false){
              propietario.pasosverbo=1;
              parsearVerbo(propietario.verbodefecto,e.getX(),e.getY());
            }
        }//eventos en aventura
        if(e.getY()>(int)(propietario.sis.PANTALLAVERTICAL*0.66)){
            if(e.getX()<(int)(propietario.sis.PANTALLAHORIZONTAL*0.45)){
                    propietario.fijarverbo=true;
                    System.out.println("MouseClicked "+propietario.fijarverbo);
               //Zona de verbos
               if(e.getX()<88){
                    if(e.getY()>320 && e.getY()<374){
                        parsearVerbo((Verbo)propietario.verbos.elementAt(0),e.getX(),e.getY());
                    }else if(e.getY()<418 && e.getY()>374){
                        parsearVerbo((Verbo)propietario.verbos.elementAt(1),e.getX(),e.getY());
                    }else{
                        parsearVerbo((Verbo)propietario.verbos.elementAt(2),e.getX(),e.getY());
                    }
                }else if(e.getX()<176){
                    if(e.getY()>320 && e.getY()<374){
                        parsearVerbo((Verbo)propietario.verbos.elementAt(3),e.getX(),e.getY());
                    }else if(e.getY()<418 && e.getY()>374){
                        parsearVerbo((Verbo)propietario.verbos.elementAt(4),e.getX(),e.getY());
                    }else{
                        parsearVerbo((Verbo)propietario.verbos.elementAt(5),e.getX(),e.getY());
                    }
                }else
                {
                    if(e.getY()>320 && e.getY()<374){
                        parsearVerbo((Verbo)propietario.verbos.elementAt(6),e.getX(),e.getY());
                    }else if(e.getY()<418 && e.getY()>374){
                        parsearVerbo((Verbo)propietario.verbos.elementAt(7),e.getX(),e.getY());
                    }else{
                        parsearVerbo((Verbo)propietario.verbos.elementAt(8),e.getX(),e.getY());
                    }
                }
            }else{
                if(propietario.fijarverbo==true){
                    parsearVerbo(propietario.verboActual,e.getX(),e.getY());
                }else if(propietario.fijarverbo==false){
                    propietario.pasosverbo=1;
                    parsearVerbo(propietario.verbodefecto,e.getX(),e.getY());
            }
            }}
        //eventos en controles
       }else{
           int desplazamientok=(int)((propietario.sis.PANTALLAVERTICAL*0.33)/propietario.sis.panelconversacion.TAMANO);
           if(e.getY()>(int)(propietario.sis.PANTALLAVERTICAL*0.66)){
               if(e.getX()<30){}else{
                   for (int i=(int)(propietario.sis.PANTALLAVERTICAL*0.62), f=1;i<propietario.sis.PANTALLAVERTICAL-desplazamientok+1;i=i+desplazamientok,f++){
                   if(e.getY()>i){propietario.sis.panelconversacion.seleccionaOpcion(f); }
                   }
               }

           }

       }
    }
    /**
     * Gestor del evento pulsacion del raton.
     * @param e MouseEvent evento del raron.
     */
    public void mousePressed(MouseEvent e) {

    }
    /**
     * Gestor del evento levantar el dedo del raton.
     * @param e MouseEvent evento del raron.
     */
    public void mouseReleased(MouseEvent e) {

    }
    /**
     * Gestor del evento entrada del cursos del raton en la aventura.
     * @param e MouseEvent evento del raron.
     */
    public void mouseEntered(MouseEvent e) {
        propietario.update(propietario.getGraphics());
        try{
        if(!propietario.habitacionActual.procedimiento.isEmpty()){
                EjecutarAcciones exe=new EjecutarAcciones(propietario.sis,((Accion)propietario.habitacionActual.procedimiento.get(0)).acciones,propietario.room,propietario.getGraphics(),propietario);
                //habitacionActual.procedimiento.remove(0);
        }
        }catch(NullPointerException ex){}
    }
    /**
     * Gestor del evento salida del cursos del raton de la aventura.
     * @param e MouseEvent evento del raron.
     */
    public void mouseExited(MouseEvent e) {

    }
    /**
     * Gestor del evento arrastre del raton.
     * @param e MouseEvent evento del raron.
     */
    public void mouseDragged(MouseEvent e) {

    }
    /**
     * Gestor del evento movimiento del raton.
     * @param e MouseEvent evento del raron.
     */
    public void mouseMoved(MouseEvent e) {
        Graphics2D h=(Graphics2D) propietario.getGraphics();
        //Control de Eventos.
        try{
        if (propietario.sis.paneldeconversacion==false){
        for(int k=0;k<propietario.habitacionActual.eventos.size();k++){
            Comparar comp=new Comparar(((Evento)propietario.habitacionActual.eventos.get(k)).condicion ,propietario.habitacionActual);
            if(comp.getResultado()==true){
                System.out.println("Colision!!!!!!!!");
                EjecutarAcciones exe=new EjecutarAcciones(propietario.sis,((Evento)propietario.habitacionActual.eventos.get(k)).acciones,propietario.room,propietario.getGraphics(),propietario);
            }
        }
        propietario.cursorx=e.getX();
        propietario.cursory=e.getY();
         h.setColor(propietario.sis.inventario.getPapel() );
         h.fill3DRect(0, ((int)(propietario.sis.PANTALLAVERTICAL*0.62)), propietario.sis.PANTALLAHORIZONTAL, 20,false);
         h.setColor(propietario.sis.inventario.getTinta() );
         DibujarCajas cajas=new DibujarCajas(propietario.habitacionActual.elementos,propietario);
        if(propietario.fijarverbo==true){
            if(e.getY()<((int)(propietario.sis.PANTALLAVERTICAL*0.62))){
            h.drawString(propietario.verboActual.getEtiqueta()+" "+cajas.evaluarPosicion(propietario.cursorx, propietario.cursory),((int)(propietario.sis.PANTALLAVERTICAL*0.62)), ((int)(propietario.sis.PANTALLAVERTICAL*0.65)));
            }
            if(e.getY()>(int)(propietario.sis.PANTALLAVERTICAL*0.66) && e.getX()>(int)(propietario.sis.PANTALLAHORIZONTAL*0.45)){
                int k=0;
                int desplazamientox=(int)((propietario.sis.PANTALLAHORIZONTAL*0.55)/(propietario.sis.inventario.TAMANO/2));
                int desplazamientoy=(int) ((propietario.sis.PANTALLAVERTICAL*0.33)/2);
                h.setColor(propietario.sis.inventario.getPapel() );
                h.fill3DRect(0, ((int)(propietario.sis.PANTALLAVERTICAL*0.62)), propietario.sis.PANTALLAHORIZONTAL, 20,false);
                h.setColor(propietario.sis.inventario.getTinta() );
                h.drawString(propietario.verboActual.getEtiqueta()+" "+cajas.evaluarPosicionInventario(e.getX(), e.getY(), desplazamientox, desplazamientoy, propietario),((int)(propietario.sis.PANTALLAVERTICAL*0.62)), ((int)(propietario.sis.PANTALLAVERTICAL*0.65)));

            }
        }
        else if(propietario.fijarverbo==false){
            propietario.verboActual=propietario.verbodefecto;
            if(e.getY()<((int)(propietario.sis.PANTALLAVERTICAL*0.62))){
                h.drawString(propietario.verboActual.getEtiqueta()+" "+cajas.evaluarPosicion(e.getX(), e.getY() ) ,((int)(propietario.sis.PANTALLAVERTICAL*0.62)), ((int)(propietario.sis.PANTALLAVERTICAL*0.65)));
            }//eventos en aventura

        if(e.getY()>(int)(propietario.sis.PANTALLAVERTICAL*0.66)){
            //Zona de elementos
            int k=0;
            int desplazamientox=(int)((propietario.sis.PANTALLAHORIZONTAL*0.55)/(propietario.sis.inventario.TAMANO/2));
            int desplazamientoy=(int) ((propietario.sis.PANTALLAVERTICAL*0.33)/2);

            //Zona de inventario
            if(e.getX()>(int)(propietario.sis.PANTALLAHORIZONTAL*0.45)){            
                    h.setColor(propietario.sis.inventario.getPapel() );
                    h.fill3DRect(0, ((int)(propietario.sis.PANTALLAVERTICAL*0.62)), propietario.sis.PANTALLAHORIZONTAL, 20,false);
                    h.setColor(propietario.sis.inventario.getTinta() );
                    h.drawString(propietario.verboActual.getEtiqueta()+" "+cajas.evaluarPosicionInventario(e.getX(), e.getY(), desplazamientox, desplazamientoy, propietario),((int)(propietario.sis.PANTALLAVERTICAL*0.62)), ((int)(propietario.sis.PANTALLAVERTICAL*0.65)));
            }

            if(e.getX()<(int)(propietario.sis.PANTALLAHORIZONTAL*0.45)){
               //Zona de verbos
                h.setColor(propietario.sis.inventario.getPapel() );
                h.fill3DRect(0, ((int)(propietario.sis.PANTALLAVERTICAL*0.62)), propietario.sis.PANTALLAHORIZONTAL, 20,false);
                h.setColor(propietario.sis.inventario.getTinta() );
                if(e.getX()<88){
                    if(e.getY()>(int)(propietario.sis.PANTALLAVERTICAL*0.66) && e.getY()<374){
                        h.drawString(((Verbo)propietario.verbos.elementAt(0)).getEtiqueta(),((int)(propietario.sis.PANTALLAVERTICAL*0.62)), ((int)(propietario.sis.PANTALLAVERTICAL*0.65)));
                    }else if(e.getY()<418 && e.getY()>374){
                        h.drawString(((Verbo)propietario.verbos.elementAt(1)).getEtiqueta(),((int)(propietario.sis.PANTALLAVERTICAL*0.62)), ((int)(propietario.sis.PANTALLAVERTICAL*0.65)));
                    }else if(e.getY()>(int)(propietario.sis.PANTALLAVERTICAL*0.66)){
                        h.drawString(((Verbo)propietario.verbos.elementAt(2)).getEtiqueta(),((int)(propietario.sis.PANTALLAVERTICAL*0.62)), ((int)(propietario.sis.PANTALLAVERTICAL*0.65)));
                    }
                }else if(e.getX()<176){
                    if(e.getY()>(int)(propietario.sis.PANTALLAVERTICAL*0.66) && e.getY()<374){
                        h.drawString(((Verbo)propietario.verbos.elementAt(3)).getEtiqueta(),((int)(propietario.sis.PANTALLAVERTICAL*0.62)), ((int)(propietario.sis.PANTALLAVERTICAL*0.65)));
                    }else if(e.getY()<418 && e.getY()>374){
                        h.drawString(((Verbo)propietario.verbos.elementAt(4)).getEtiqueta(),((int)(propietario.sis.PANTALLAVERTICAL*0.62)), ((int)(propietario.sis.PANTALLAVERTICAL*0.65)));
                    }else if(e.getY()>(int)(propietario.sis.PANTALLAVERTICAL*0.66)){
                       h.drawString(((Verbo)propietario.verbos.elementAt(5)).getEtiqueta(),((int)(propietario.sis.PANTALLAVERTICAL*0.62)), ((int)(propietario.sis.PANTALLAVERTICAL*0.65)));
                    }
                }else
                {  if(e.getY()>(int)(propietario.sis.PANTALLAVERTICAL*0.66) && e.getY()<propietario.sis.PANTALLAVERTICAL*0.77){
                        h.drawString(((Verbo)propietario.verbos.elementAt(6)).getEtiqueta(),((int)(propietario.sis.PANTALLAVERTICAL*0.62)), ((int)(propietario.sis.PANTALLAVERTICAL*0.65)));
                    }else if(e.getY()<(propietario.sis.PANTALLAVERTICAL*0.88) && e.getY()>(propietario.sis.PANTALLAVERTICAL*0.77)){
                        h.drawString(((Verbo)propietario.verbos.elementAt(7)).getEtiqueta(),((int)(propietario.sis.PANTALLAVERTICAL*0.62)), ((int)(propietario.sis.PANTALLAVERTICAL*0.65)));
                    }else if(e.getY()>(int)(propietario.sis.PANTALLAVERTICAL*0.66)){
                        h.drawString(((Verbo)propietario.verbos.elementAt(8)).getEtiqueta(),((int)(propietario.sis.PANTALLAVERTICAL*0.62)), ((int)(propietario.sis.PANTALLAVERTICAL*0.65)));
                    }
                }
            }else{
                if(propietario.fijarverbo==true){
                    h.drawString(propietario.verboActual.getEtiqueta()+" "+cajas.evaluarPosicion(propietario.cursorx, propietario.cursory),((int)(propietario.sis.PANTALLAVERTICAL*0.62)), ((int)(propietario.sis.PANTALLAVERTICAL*0.65)));
                }
                else if(propietario.fijarverbo==false){
                    h.drawString(propietario.verboActual.getEtiqueta()+" "+cajas.evaluarPosicion(e.getX(), e.getY() ) ,((int)(propietario.sis.PANTALLAVERTICAL*0.62)), ((int)(propietario.sis.PANTALLAVERTICAL*0.65)));
        //eventos en aventura
            }
        }}}}else{
           int k=(int)((propietario.sis.PANTALLAVERTICAL*0.33)/propietario.sis.panelconversacion.TAMANO);
           if(e.getY()>(int)(propietario.sis.PANTALLAVERTICAL*0.66)){
               if(e.getX()<30){
               }else{
                   for (int i=0;i<propietario.sis.panelconversacion.TAMANO;i++){
                    if(e.getY()>((int)(propietario.sis.PANTALLAVERTICAL*0.66))+((i+1)*k)){
                      h.setColor(propietario.sis.inventario.getPapel() );
                      h.fill3DRect(0, ((int)(propietario.sis.PANTALLAVERTICAL*0.62)), propietario.sis.PANTALLAHORIZONTAL, 20,false);
                      h.setColor(propietario.sis.inventario.getTinta() );
                      h.drawString(propietario.sis.panelconversacion.opciones.get(i).toString(),((int)(propietario.sis.PANTALLAVERTICAL*0.62)), ((int)(propietario.sis.PANTALLAVERTICAL*0.65)));
                   }
                   }
               }

           }}        
        }catch(NullPointerException exc){}
    }
    /**
     * Metodo que parsea las acciones de un verbo.
     * @param verb Verbo.
     * @param x Posicion x del ratón.
     * @param y Posicion y del ratón.
     */
    public void parsearVerbo(Verbo verb,int x,int y){
        Graphics2D h=(Graphics2D) propietario.getGraphics();
        int desplazamientox=(int)((propietario.sis.PANTALLAHORIZONTAL*0.55)/(propietario.sis.inventario.TAMANO/2));
        int desplazamientoy=(int) ((propietario.sis.PANTALLAVERTICAL*0.33)/2);

        if(verb.nombre.equals("Andar")&& propietario.pasosverbo==1 ||verb.nombre.equals("Andar") && verb==propietario.verbodefecto){
            Vector accion=new Vector();
            accion.add(1);
            accion.add(propietario.sis.personaje);
            accion.add(propietario.cursorx);
            accion.add(propietario.cursory);
            accion.add(0);
            Vector acciones=new Vector();
            acciones.add(accion);
            EjecutarAcciones exe=new EjecutarAcciones(propietario.sis,acciones,propietario.room,propietario.getGraphics(),propietario);
            propietario.pasosverbo=0;
            propietario.fijarverbo=false;
        }else if(propietario.pasosverbo==0){
            propietario.verboActual=verb;
            h.setColor(propietario.sis.inventario.getPapel() );
            h.fill3DRect(0, ((int)(propietario.sis.PANTALLAVERTICAL*0.62)), propietario.sis.PANTALLAHORIZONTAL, 20,false);
            h.setColor(propietario.sis.inventario.getTinta() );
            h.drawString(propietario.verboActual.getEtiqueta(),((int)(propietario.sis.PANTALLAVERTICAL*0.62)), ((int)(propietario.sis.PANTALLAVERTICAL*0.65)));
            propietario.pasosverbo=1;
        }else if (propietario.pasosverbo==1){
            DibujarCajas cajas=new DibujarCajas(propietario.habitacionActual.elementos,propietario);
            h.setColor(propietario.sis.inventario.getPapel() );
            h.fill3DRect(0, ((int)(propietario.sis.PANTALLAVERTICAL*0.62)), propietario.sis.PANTALLAHORIZONTAL, 20,false);
            h.setColor(propietario.sis.inventario.getTinta() );
            if(y<(int)(propietario.sis.PANTALLAVERTICAL*0.66)){
                h.drawString(propietario.verboActual.getEtiqueta()+" "+cajas.evaluarPosicion(x, y),((int)(propietario.sis.PANTALLAVERTICAL*0.62)), ((int)(propietario.sis.PANTALLAVERTICAL*0.65)));
            }else{h.drawString(propietario.verboActual.getEtiqueta()+" "+cajas.evaluarPosicionInventario(x, y,desplazamientox, desplazamientoy, propietario),((int)(propietario.sis.PANTALLAVERTICAL*0.62)), ((int)(propietario.sis.PANTALLAVERTICAL*0.65)));
}

            if(propietario.verboActual.sentencia>1){
                propietario.pasosverbo=2;
            }else if(propietario.verboActual.sentencia==1){
            propietario.pasosverbo=0;
            propietario.fijarverbo=false;
            EvaluarExpresion eval;
            if(y<(int)(propietario.sis.PANTALLAVERTICAL*0.66)){
                if(cajas.getElemento(x, y).acciones.isEmpty()){
                    eval=new EvaluarExpresion(propietario.verboActual,cajas.getElemento(x, y),propietario.globales,propietario.locales);
                }else{
                    eval=new EvaluarExpresion(propietario.verboActual,cajas.getElemento(x, y),propietario.globales,propietario.locales,(cajas.getElemento(x, y)).acciones);
                }
                EjecutarAcciones exe=new EjecutarAcciones(propietario.sis,eval.getAcciones(),propietario.room,propietario.getGraphics(),propietario);
            }else if(y>(int)(propietario.sis.PANTALLAVERTICAL*0.66) && x>291){
                System.out.println(cajas.evaluarPosicionInventario(x, y, desplazamientox, desplazamientoy, propietario) );
                if(cajas.getElementoInventario().acciones.isEmpty()){
                    eval=new EvaluarExpresion(propietario.verboActual,cajas.getElementoInventario(),propietario.globales,propietario.locales);
                }else{
                    eval=new EvaluarExpresion(propietario.verboActual,cajas.getElementoInventario(),propietario.globales,propietario.locales,(cajas.getElemento(x, y)).acciones);
                }
            }

            }
        }
    }
}
